      SUBROUTINE DE00D(F,FJ,M,JSTART,HMIN,EPS,P,YX,X,H,BUL,XP,YP,A,E1,  DE000010
     1                 E2,E3,E4,R,R0,R1,R2,R3,YD,IERR)                  DE000020
         INTEGER IERR,JSTART,M                                          DE000030
         DOUBLE PRECISION A,E1,E2,E3,E4,EPS,H,HMIN,P,R,R0,R1,R2,R3,X,
     1                    XP,YD,YP,YX                                   DE000040
         LOGICAL BUL                                                    DE000050
         DIMENSION A(M,M),E1(M,M),E2(M,M),E3(M,M),E4(M,M),R(M),R0(M),   DE000060
     1             R1(M),R2(M),R3(M),YD(M),YP(M),YX(M)                  DE000070
         DOUBLE PRECISION DABS,DSIGN                                    DE000080
         EXTERNAL AME2D,DE00DS,DE04DQ,FJ,UTDE21                         DE000090
         INTEGER I,J                                                    DE000100
         DOUBLE PRECISION C1,EPS1                                       DE000110
         LOGICAL BULD,BULEX,BULHM                                       DE000120
       IERR = 0                                                         DE000130
       EPS1 = EPS/32.D0                                                 DE000140
       BULD = .TRUE.                                                    DE000150
       BULHM = .FALSE.                                                  DE000160
       BULEX = .FALSE.                                                  DE000170
       IF (JSTART) 50, 70, 10                                           DE000180
   10  CONTINUE                                                         DE000190
       IF (JSTART .EQ. 1) GO TO 100                                     DE000200
          IF (JSTART .EQ. 2) GO TO 20                                   DE000210
             GO TO 80                                                   DE000220
   20  CONTINUE                                                         DE000230
       DO 40 J = 1, M                                                   DE000240
          DO 30 I = 1, M                                                DE000250
             E1(I,J) = E2(I,J)                                          DE000260
   30     CONTINUE                                                      DE000270
   40  CONTINUE                                                         DE000280
       GO TO 90                                                         DE000290
   50  CONTINUE                                                         DE000300
       DO 60 I = 1, M                                                   DE000310
          YX(I) = YP(I)                                                 DE000320
   60  CONTINUE                                                         DE000330
       X = XP                                                           DE000340
   70  CONTINUE                                                         DE000350
       CALL FJ(X,YX,A,M)                                                DE000360
   80  CONTINUE                                                         DE000370
       C1 = H/4.D0                                                      DE000380
       CALL AME2D(A,C1,M,E1,R,E3,E4)                                    DE000390
       IF (BULEX) GO TO 100                                             DE000400
   90  CONTINUE                                                         DE000410
       CALL DE04DQ(M,E1,E2)                                             DE000420
  100  CONTINUE                                                         DE000430
       C1 = H/2.D0                                                      DE000440
       CALL DE00DS(F,M,X,YX,H,A,E2,YD,R1,R2,R3)                         DE000450
       CALL DE00DS(F,M,X,YX,C1,A,E1,R0,R1,R2,R3)                        DE000460
       CALL DE00DS(F,M,X + C1,R0,C1,A,E1,R,R1,R2,R3)                    DE000470
       DO 110 I = 1, M                                                  DE000480
          R1(I) = (R(I) - YD(I))/15.D0                                  DE000490
          C1 = DABS(R1(I))                                              DE000500
          IF (DABS(R(I)) .GE. P) C1 = C1/DABS(R(I))                     DE000510
          IF (C1 .GT. EPS1) BULD = .FALSE.                              DE000520
          IF (C1 .GE. EPS) GO TO 140                                    DE000530
  110     CONTINUE                                                      DE000540
          DO 120 I = 1, M                                               DE000550
             YP(I) = YX(I)                                              DE000560
  120     CONTINUE                                                      DE000570
          XP = X                                                        DE000580
          DO 130 I = 1, M                                               DE000590
             YX(I) = R(I)                                               DE000600
  130     CONTINUE                                                      DE000610
          X = X + H                                                     DE000620
          IF (BULD) H = H*2.D0                                          DE000630
          GO TO 180                                                     DE000640
  140  CONTINUE                                                         DE000650
       IF (BULHM) GO TO 170                                             DE000660
          H = H/2.D0                                                    DE000670
          BUL = .FALSE.                                                 DE000680
          BULEX = .TRUE.                                                DE000690
          DO 160 J = 1, M                                               DE000700
             DO 150 I = 1, M                                            DE000710
                E2(I,J) = E1(I,J)                                       DE000720
  150        CONTINUE                                                   DE000730
  160     CONTINUE                                                      DE000740
          IF (DABS(H) .GT. DABS(HMIN)) GO TO 80                         DE000750
             H = DSIGN(HMIN,H)                                          DE000760
             BULHM = .TRUE.                                             DE000770
             BULEX = .FALSE.                                            DE000780
             GO TO 80                                                   DE000790
  170  CONTINUE                                                         DE000800
       IERR = 65                                                        DE000810
       CALL UTDE21(IERR,0)                                              DE000820
  180  CONTINUE                                                         DE000830
       JSTART = 1                                                       DE000840
       IF (BULD) JSTART = 2                                             DE000850
       RETURN                                                           DE000860
      END                                                               DE000870
